__atomic_notifier_call_chain
Prev | Kernel utility functions | Next

## Name

__atomic_notifier_call_chain — Call functions in an atomic notifier chain

## Synopsis

`int __kprobes __atomic_notifier_call_chain (` | struct atomic_notifier_head * | nh,
| unsigned long | val,
| void * | v,
| int | nr_to_call,
| int * | nr_calls`)`;

## Arguments

`nh`

  Pointer to head of the atomic notifier chain

`val`

  Value passed unmodified to notifier function

`v`

  Pointer passed unmodified to notifier function

`nr_to_call`

  See the comment for notifier_call_chain.

`nr_calls`

  See the comment for notifier_call_chain.

## Description

Calls each function in a notifier chain in turn. The functions run in an atomic context, so they must not block. This routine uses RCU to synchronize with changes to the chain.

If the return value of the notifier can be and'ed with `NOTIFY_STOP_MASK` then `atomic_notifier_call_chain` will return immediately, with the return value of the notifier function which halted execution. Otherwise the return value is the return value of the last notifier function called.

Prev | Up | Next
atomic_notifier_chain_unregister | Home | blocking_notifier_chain_register